define bi_anyenv::env (
    $env = undef,
    $user = undef,
    $http_proxy = undef,
    $https_proxy = undef,
) {
    
    if $env == undef or !is_string($env) { 
        fail("'env' must be defined") 
    }
    
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    require ::bi_anyenv
    require ::bi_grep # For scripts
    require ::bi_coreutils # For scripts
    require ::bi_bash
    include ::bi_anyenv::profile_d
    require ::bi_anyenv::env_check
    require ::bi_anyenv::env_install
    
    $title_prefix = "$title"
    $local_dir = "/home/$user/.anyenv"
    
    bi_git::clone { "$title_prefix/$local_dir":
        git_url => "$::bi_anyenv::git_url",
        local_dir => $local_dir,
        user => $user,
        http_proxy => $http_proxy,
        https_proxy => $https_proxy,
    }
    
    if $http_proxy != undef and is_string($http_proxy) {
        $arg_http_proxy = "http_proxy=$http_proxy"
    } else {
        $arg_http_proxy = ""
    }
    
    if $https_proxy != undef and is_string($https_proxy) {
        $arg_https_proxy = "https_proxy=$https_proxy"
    } else {
        $arg_https_proxy = ""
    }
    
    $command = "$arg_http_proxy $arg_https_proxy $::bi_anyenv::env_install::path $env"
    
    $unless = "$::bi_anyenv::env_check::path $env"
    
    bi_bash::exec { "$title_prefix/$command":
        command => $command,
        unless => $unless,
        user => $user,
        require => [
            Class[::bi_anyenv::profile_d],
            Bi_git::Clone["$title_prefix/$local_dir"],
        ],
    }
}
